#!/usr/bin/perl -w
#
# $Id: InfoBox.pm,v 1.4 2003/06/11 02:58:28 solovam Exp $
#
# InfoBox class
#
package InfoBox;

use Gtk;
use Misc;
use strict;

my @labels = ('Networks', 'Packets', 'Crypt', 'Weak', 'Noise', 'Dropped', 'Rate', 'Signal');

#
# Constructor
#
sub new
{
	my $type = shift;
	my $self = {};
	bless $self, $type;

	my $frame = new Gtk::Frame(undef);
	$self->{'frame'} = $frame;
	my $vbox = new Gtk::VBox($false, 5);
	$frame->add($vbox);

	for my $l (@labels)
	{
		my $hbox = new Gtk::HBox($false, 1);

		my $nlabel = new Gtk::Label($l . ': ');
		$nlabel->set_justify('left');
		$hbox->pack_start($nlabel, $false, $false, 5);

		my $vlabel = new Gtk::Label('');
		$vlabel->set_justify('right');
		$hbox->pack_end($vlabel, $false, $false, 5);

		$vbox->pack_start($hbox, $false, $false, 3);
	
		$self->{'label'}{$l} = $vlabel;
	}
	$frame->show_all();

	return $self;
}

#
# Destructor
#
sub DESTROY
{
	my $self = shift;
	if(defined $self->getWidget())
	{
		$self->getWidget()->destroy();
	}
}

#
# Remove all stored data
#
sub flush
{
	my $self = shift;
	for my $l (@labels)
	{
		$self->{'label'}{$l}->set_text('');
	}
}

#
# Called when info is updated
#
sub update
{
	my $self = shift;
	my $conn = shift;
	my $data = shift;
	
	if($data->{'changed'} eq 'info')
	{
		for my $l (@labels)
		{
			$self->{'label'}{$l}->set_text($conn->getInfo($l));
		}
	}
}

#
# Get Gtk widget
#
sub getWidget
{
	my $self = shift;
	return($self->{'frame'});
}
