#!/usr/bin/perl -w
#
# $Id: StatusBar.pm,v 1.5 2003/06/11 03:05:28 solovam Exp $
#
# StatusBar class
#
package StatusBar;

use strict;
use Gtk;
use Misc;

#
# Constructor
#
sub new
{
	my $type = shift;
	my $self = {};
	bless $self, $type;

	$self->{'statusBar'} = new Gtk::Statusbar();
	$self->{'sbContext'} = $self->{'statusBar'}->get_context_id('status line');
	$self->{'statusBar'}->show();

	return $self;
}

#
# Destructor
#
sub DESTROY
{
	my $self = shift;
	if(defined $self->getWidget())
	{
		$self->getWidget()->destroy();
	}
}

#
# Called when status is updated
#
sub update
{
	my $self = shift;
	my $conn = shift;
	my $data = shift;

	if($data->{'changed'} eq 'status')
	{
		$self->{'statusBar'}->push($self->{'sbContext'}, $conn->getStatus());
	}
}

#
# Flush off all the accumulated data
#
sub flush
{
	my $self = shift;
	while(1)
	{
		if(!$self->{'statusBar'}->pop($self->{'sbContext'}))
		{
			last;
		}
	}
}

#
# Get widget
#
sub getWidget
{
	my $self = shift;
	return($self->{'statusBar'});
}

1;
